﻿using UnityEngine;
using System.Collections;
using System;

public class flamesound3 : MonoBehaviour {
	int objno = 3; // change this for multiple RTcmix instantiations
    rtcmixmain RTcmix;
    private bool did_start = false;

    public TextAsset flamescore1, flamescore2;
	string fscore1, fscore2;

	public float flameamp;

	private getMyTransform localsrc; // to get position relative to 'observer'

    private void Awake()
    {
        RTcmix = GameObject.Find("RTcmixmain").GetComponent<rtcmixmain>();
        localsrc = GameObject.Find("observer").GetComponent<getMyTransform>();
    }


    // Use this for initialization
    void Start () {
		flameamp = 1.0f;

		fscore1 = flamescore1.text;
		fscore2 = flamescore2.text;

		RTcmix.initRTcmix (objno);

        RTcmix.SendScore(fscore1, objno);
        RTcmix.SendScore ("MAXBANG(0.1)", objno);

        did_start = true;
	}
	
	// Update is called once per frame
	void Update () {
        if (!did_start) return;

        Vector3 srcpos = localsrc.getTransform (gameObject); // this source relative to the 'observer' object
        // note swap of y and z axes
        RTcmix.setpfieldRTcmix (1, srcpos.x, objno);
        RTcmix.setpfieldRTcmix (2, srcpos.z, objno);
        RTcmix.setpfieldRTcmix (3, srcpos.y, objno);
        if (flameamp > 1.0f)
            flameamp = 1.0f;
		if (flameamp < 0.0f)
            flameamp = 0.0f;
        RTcmix.setpfieldRTcmix (4, flameamp, objno);
	}

	// this function is called by unity for every buffer of sound samples computed
	void OnAudioFilterRead(float[] data, int channels) {
        if (!did_start) return;

		RTcmix.runRTcmix (data, objno, 0);

		if (RTcmix.checkbangRTcmix (objno) == 1) {
			RTcmix.SendScore (fscore2, objno);
		}
	}

    void OnApplicationQuit()
    {
        RTcmix = null;
        did_start = false;
    }
}
